<?php declare(strict_types=1);

use GuzzleHttp\Client as Client;
use GuzzleHttp\Exception;
use GuzzleHttp\Exception\ServerException;
use GuzzleHttp\Exception\ClientException;

namespace nogueiracodes\RaspberryBot\Bot\Helpers;

use Exception;
use InvalidArgumentException;
use Zttp\Zttp;

class CatAPI {

    private $headers;


    private $baseURL = "https://api.thecatapi.com/v1/";

    public function __construct()
    {
        $this->headers = [
            'x-api-key' => $_ENV['CAT_API_KEY']
        ];
    }

    public function getCatPicture($count = 1, $size = "small"): string {
        
        // anti smart-ass device
        if ($count = 0)
            $count = 1;

        $catPic = Zttp::withHeaders($this->headers)->get($this->baseURL . 'images/search' .  http_build_query([
            'limit' => $count,
            'size' => $size,
            'has_breeds' => false
        ]));

        if ($catPic->isOk())
        {
            $results = $catPic->json();
            $pics = [];

            if (count($results) == 1)
            {
                return $results[0]['url'];
            }

            foreach($results as $result)
            {  
                array_push($pics, $result['url']);
            }

            return implode(PHP_EOL, $pics);
            
        }
        else
        {
            throw new Exception('Sorry, but I couldn\'t get you a good cat picture this time. Try again later!');
        }

    }

}